import { WritableComputedRef } from 'vue';
import { CommonProps } from '@/common/mixin/props';
import type { Value } from '@/common/types/select';
import type { GridColumns } from './types';
interface Props extends CommonProps {
    dataItems: any[] | undefined;
    columns: GridColumns[];
    itemsOnPage?: number;
    showAddButtons?: boolean;
    hasFilter?: boolean;
    colorAlternation?: boolean;
    hideHeader?: boolean;
    query?: string;
    filterFields?: string[];
    filterCaseSensitive?: boolean;
}
declare const _default: __VLS_WithTemplateSlots<import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    showAddButtons: boolean;
    itemsOnPage: number;
    hasFilter: boolean;
    colorAlternation: boolean;
    hideHeader: boolean;
    query: string;
}>, {
    items: WritableComputedRef<object[]>;
    grid: import("vue").ComponentInternalInstance | null;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    mount: () => void;
    unmount: () => void;
    "update:modelValue": (value: Value) => void;
    "model-value-updated": (value: Value) => void;
    focusin: () => void;
    focusout: () => void;
    keydown: (event: KeyboardEvent) => void;
    search: (query: string) => void;
    queryUpdate: (value: string) => void;
    rowClick: (row: Record<string, unknown>, rowRef: any) => void;
    afterChange: (value: unknown) => void;
    afterEdit: (value: unknown) => void;
    beforeEdit: (value: unknown) => void;
    beforeChange: (value: unknown) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    showAddButtons: boolean;
    itemsOnPage: number;
    hasFilter: boolean;
    colorAlternation: boolean;
    hideHeader: boolean;
    query: string;
}>>> & {
    onFocusin?: (() => any) | undefined;
    onFocusout?: (() => any) | undefined;
    onKeydown?: ((event: KeyboardEvent) => any) | undefined;
    onMount?: (() => any) | undefined;
    onUnmount?: (() => any) | undefined;
    "onModel-value-updated"?: ((value: Value) => any) | undefined;
    "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
    onAfterChange?: ((value: unknown) => any) | undefined;
    onSearch?: ((query: string) => any) | undefined;
    onQueryUpdate?: ((value: string) => any) | undefined;
    onBeforeEdit?: ((value: unknown) => any) | undefined;
    onAfterEdit?: ((value: unknown) => any) | undefined;
    onBeforeChange?: ((value: unknown) => any) | undefined;
    onRowClick?: ((row: Record<string, unknown>, rowRef: any) => any) | undefined;
}, {
    showAddButtons: boolean;
    hasFilter: boolean;
    query: string;
    itemsOnPage: number;
    colorAlternation: boolean;
    hideHeader: boolean;
}, {}>, Partial<Record<string, (_: {
    item: any;
    row: Record<string, unknown> | undefined;
    setTrueFlag: () => void;
}) => any>> & Partial<Record<string, (_: {
    value: unknown;
    update: (value: unknown) => void;
    isChangeAllowed: boolean;
    toggle: () => void;
    customChange: (value: string, view?: string | undefined) => void;
    row: Record<string, unknown> | undefined;
    hideEdit: () => void;
    item: any;
    setTrueFlag: () => void;
}) => any>>>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
