import { type Ref } from 'vue';
export interface InitialFiles {
    file: File;
}
export default function (initialFilesRef: Ref<InitialFiles[]>): {
    files: Ref<File[]>;
    addFiles: (newFiles: File[]) => void;
    removeFile: (file: File) => void;
};
declare class UploadableFile implements UploadableFile {
    constructor(file: File);
    file: File;
    id: string;
    url: string;
    status: 'uploading' | 'done' | 'error' | null;
}
interface UploadableFile {
    file: File;
    id: string;
    url: string;
    status: 'uploading' | 'done' | 'error' | null;
}
export type { UploadableFile };
